/***********************************************************************

    FlyWheel Control

	MOD FESS Main.C :

_______________________________________________________________________
    WHAT    |    WHEN   |      WHO		| WHY
------------------------------------------------------------------------
	0.1		| 01/06/11  | IC			|
			|			|				| 
------------------------------------------------------------------------


////////////////////////////////
////   VARIABLES' GRAMMAR	////
////////////////////////////////
CONSTANTS_UPPERCASE_SPACES_UNDERLINE
VariablesWithFirstCapitalNoSpaces
unsigned int	Var:	u_Var
	 	 int	Var:	i_Var
		long	Var:	l_Var
	   float	Var:	f_Var
 bool or bit	Var:	b_Var
	   union	Var:	n_Var
	  struct	Var:	s_Var
		char	Var:	c_Var
	 #define OPTION:	OPTION
/////////////////////////////////
*/


//#ifndef _MAINCONFIGURATION_
//#define _MAINCONFIGURATION_

//#ifdef MAINMICRO

//#include "Global.h"
//#include "VariablesMap.h"
//#include "EEPROM.h"
//#include "Can.h"
//#include "Hardware.h"
//#include "ADC.h"
//#include "Sensors.h"
#include <timer.h>
#include <p33Fxxxx.h>

/////////////////////////////////////////
/////	Set Up Configuration Bits	/////
/////////////////////////////////////////
// Pedro original code
_FBS(BWRP_WRPROTECT_OFF & BSS_NO_FLASH & RBS_NO_RAM);
_FSS(SSS_NO_FLASH & RSS_NO_RAM);
_FGS(GSS_OFF & GCP_OFF & GWRP_OFF);
_FOSCSEL(FNOSC_PRIPLL & IESO_OFF);
_FWDT(FWDTEN_OFF & WINDIS_OFF & WDTPRE_PR128 & WDTPOST_PS1);
	// Flywheel
	// This microprocessor uses its own CLOCK, it's the master
	_FOSC(POSCMD_XT & FCKSM_CSDCMD);

/*********************************************************************
#######################################################################
	MOD FESS Declarations
#######################################################################
**********************************************************************/
#define	RedPWMDutyCycle  PDC1 		//1ph o/p
#define	BluePWMDutyCycle  PDC2		//2ph o/p
#define	YellowPWMDutyCycle  PDC3	//3ph o/p

#define	HEARTBEAT_COUNTS  50000		// 50000 Connts = 100mS
#define	LED1	LATAbits.LATA10		// D1/Heartbeat LED  
#define	LED2	LATDbits.LATD10		// D2
#define	LED3	LATDbits.LATD15		// D3

unsigned int heartbeat = 0; 

int	RedSineCounter		= 0;		// Red phase LUT counter
int	BlueSineCounter	 	= 0;		// Blue phase LUT counter
int	YellowSineCounter	= 0;		// Yellow phase LUT counter

//static int SineTable[];		// declared so only called once

//##  Sine table => 100off values
//const rom int SineTable[] = {512,544,576,608,639,670,700,730,759,786,813,838,862,885,907,926,944,961,975,988,999,1008,1015,1020,1023,1023,
const int SineTable[] = {512,544,576,608,639,670,700,730,759,786,813,838,862,885,907,926,944,961,975,988,999,1008,1015,1020,1023,1023,
				        1023,1020,1015,1008,999,988,975,961,944,926,907,885,862,838,813,786,759,730,700,670,639,608,576,544,512,
				        480,448,416,385,354,324,294,265,238,211,186,162,139,117,98,80,63,49,36,25,16,9,4,1,1,1,
				        4,9,16,25,36,49,63,80,98,117,139,162,186,211,238,265,294,324,354,385,416,448,480};

//unsigned int heartbeat = 0;


//	DECLARE FUNCTIONS
/**********************************************************************/
//	void PWM_Main();
			

/////////////////////////////////////////////////////////////
////////		  M A I N   F U N C T I O N			/////////
/////////////////////////////////////////////////////////////
////////				PWM SINE OUTPUT				/////////
/////////////////////////////////////////////////////////////

void main()
{
/**********************************************************************
#######################################################################
	Set up PWM control settings
#######################################################################
**********************************************************************/

			P1TCON = 0b0000000000000000;	// Disable PWM to configure it
			P1TCON = 0;						// Disable PWM to configure it
			P1TCONbits.PTMOD = 0;			// PWM in free running mode
			P1TCONbits.PTCKPS = 0;			// PWM pre-scale 1:1
			P1TCONbits.PTOPS = 0;			// PWM post-scale 1:1

			P1TPER = 7999; 					//(Fcy/(pwm period x pre-scale))-1 ### (15bit)
											// 999=40KHz @ 40MIPs, 1333=30KHz, 1999=20KHz, 3999=10KHz, 7999=5KHz
											// for 100pts LUT & 50Hz o/p choose 5KHz = 20mS/100

// ######## Special Event Trigger - used to sync ADC ######## NOT Req as yet...........
//			P1SECMPbits.SEVTCMP = 7999; 	// Special event trig reg, compared to P1TMR to generate special event trigger ## (15bit)
//			P1SECMPbits.SEVTDIR = 0; 		// Special event trig occurs when count is upwards

//			PWM1CON1 = 0b0000000001110111;	// Enable PWM 1/2/3 + comp o/ps
			PWM1CON1bits.PEN1H = 1;			// Enable PWM 1H
			PWM1CON1bits.PEN1L = 1;			// Enable PWM 1L
			PWM1CON1bits.PEN2H = 1;			// Enable PWM 2H
			PWM1CON1bits.PEN2L = 1;			// Enable PWM 2L
			PWM1CON1bits.PEN3H = 1;			// Enable PWM 3H - Req for 3ph
			PWM1CON1bits.PEN3L = 1;			// Enable PWM 3L - Req for 3ph
			PWM1CON1bits.PEN3H = 0;			// Disable PWM 4H - Not used!!!!
			PWM1CON1bits.PEN3L = 0;			// Disable PWM 4L - Not used!!!!
			PWM1CON1bits.PMOD1 = 0;			// PWM1 complementary mode
			PWM1CON1bits.PMOD2 = 0;			// PWM2 complementary mode
			PWM1CON1bits.PMOD3 = 0;			// PWM3 complementary mode

//			PWM1CON2 = 0b0000000000000000;	// o/ps sync + 1:1 postscale
    		PWM1CON2bits.SEVOPS = 0;        // 1:1 prescaler for special event
			PWM1CON2bits.IUE = 0;           // updates are sync with time base
        	PWM1CON2bits.OSYNC = 0;         // immediate override
        	PWM1CON2bits.UDIS = 0;          // period and duty cycle can be modified

			P1TMR = 0b0000000000000000; 	//PWM timer count value reg, count up/cleared (14bit)

			PWM1CON2bits.IUE = 1;			// Immediate update of PWM enable

			P1DTCON1 = 0b1000101010001010; 	// 4*Tcy (10 =1us) A&B DT pre-scaler (& Tcy = 25nS)
			P1DTCON2 = 0b0000000000010101; 	// "0" = DT from A, "1" = DT from B 
			P1OVDCON = 0b1111111100000000; 	// DT controlled by PWM generator

		   	P1FLTACON = 0b0000000000000000; //PWM not controlled by fault i/p A
			P1FLTBCON = 0b0000000000000000; //PWM not controlled by fault i/p B

			OC1R = P1TPER; 					// PWM period is written into the OC1R reg
			OC1RS = P1TPER; 				// PWM period is written into the OC1RS reg
			OC1CONbits.OCM = 0b111;			// PWM mode with fault protection enabled

			IFS3bits.PWMIF = 0;				// PWM period match int

			TRISAbits.TRISA10 = 0;	//Set port dir 0=o/p, HeartBeat LED
			TRISDbits.TRISD10 = 0;	//Set port dir 0=o/p, LED D2
			TRISDbits.TRISD15 = 0;	//Set port dir 0=o/p, LED D3

//	void Initialise_Interrupts(void)
//	{
		//************All Interrupts Disabled. They are enabled in their indivual set up*************
		INTCON1 = 0b0000000000000000; 
		INTCON2 = 0b0000000000000000;
		IEC0    = 0b0000000000000000; // TMR2IE
		IEC1	= 0b0000000000000000; // CN Interrupt (bit 3)
		IEC2	= 0b0000000000000000; // INT6IE (bit 15)
		IEC3	= 0b0000000000000000; // INT3IE (bit5) INT4IE (bit6) T9IE (bit4) T8IE (bit3) T7IE (bit0)	
		IEC4	= 0b0000000000000000;
		IPC0	= 0b0000000000000000;
		IPC1	= 0b0000000000000000;
		IPC2	= 0b0000000000000000;
		IPC3	= 0b0000000000000000;
		IPC4	= 0b0000000000000000; // CN Priority
		IPC5	= 0b0000000000000000;
		IPC6	= 0b0000000000000000;
		IPC7	= 0b0000000000000000;
		IPC8	= 0b0000000000000000;
		IPC9	= 0b0000000000000000;
		IPC10	= 0b0000000000000000;
		IPC11	= 0b0000000000000000;
		IPC12	= 0b0000000000000000;
		IPC13	= 0b0000000000000000; //  T4IP (bits 8:10) T3IP (bits 4:6) T9IP (bits 0:2)
		IPC14	= 0b0000000000000000;
		IPC15	= 0b0000000000000000; //  DMA5IP (bits 4:6) Set-up in the DMA
		IPC16	= 0b0000000000000000;
		IPC17	= 0b0000000000000000;
//	}
	

	while (1<2)
		{
			if (RedSineCounter > 99)
   				{
   				RedSineCounter = 0;
   				}
				RedPWMDutyCycle = (int) (SineTable[RedSineCounter]);		//	call Red phase LUT
   				RedSineCounter++;

				LED2=0;		// Turn OFF LED2 - debug


/*				BluePWMDutyCycle = Sine2[BlueSineCounter];		//	call Blue phase LUT
   				BlueSineCounter++;

				YellowPWMDutyCycle = Sine3[YellowSineCounter];	//	call Yellow phase LUT
   				YellowSineCounter++;
*/
				PTCONbits.PTEN =1; 			//Enable PWM/start timer

//				LED1=1;
				LED2=1;		// Turn ON LED2 - debug
				LED3=1;		// Turn ON LED3 - debug

		// HEART BEAT BIT BEEP BEEP BEEP BEEEEEEEEEEP
			heartbeat++;
			if (heartbeat>HEARTBEAT_COUNTS)
				{
				heartbeat=0;
				//HEARTBEAT_LED=~HEARTBEAT_LED;
				LED1=~LED1;     // change LED1 o/p to opposite ie.NOT
				}
//#####################################################################
				// Wait for P1TMR Timer to = P1TPER ie.5KHz PWM period
				// stop counter
				// reset P1TMR
//#####################################################################

loop:				while	(IFS3bits.PWMIF = 0)		// Int is set when P1TMR = 0
						{
							Nop();
							goto	 loop;
						}
//				IEC1bits.CNIE = 0;				// Disables the CN interrupt
//				IFS1bits.CNIF = 0;				// Clear the interrupt flag
//				IFS3bits.T9IF = 0;				// Clear the T9 interrupt flag
//				IEC3bits.T9IE = 1;				// ENABLE the interrupt flag



		}
}


////////////////////////////////////
////    E N D   O F   F I L E	////
////////////////////////////////////
